// -*- C++ -*-
// File: MainForm.c
//
// Created: Mon Jul 24 19:41:32 2000
//
// $Id: MainForm.c,v 1.1.1.1 2002/07/17 12:47:32 oskin Exp $
//

#include <PalmOS.h>
#include "callback.h"
#include "RuSMS.h"
#include "cSMS/Serial.h"

MemHandle MobilePhoneLookup()
{
	UInt16 cardNo;
	LocalID dbID;
	UInt32 result;
	DmSearchStateType searchState;
	Err err;
	AddrLookupParamsType params;

	MemSet(&params, sizeof(params), 0);
	params.title = NULL;
	params.pasteButtonText = NULL;
	params.formatStringP = "^mobile";
	params.field1 = addrLookupSortField;
	params.field2 = addrLookupMobile;
	params.field2Optional = false;
	params.userShouldInteract = true;
	*params.lookupString = 0;
	err = DmGetNextDatabaseByTypeCreator (true, &searchState,
										  sysFileTApplication,
										  sysFileCAddress, true,
										  &cardNo, &dbID);
	if (err) {
		ErrMsgRes(err, strNoAddrBook);
		return 0;
	}
	err = SysAppLaunch (cardNo, dbID, 0, sysAppLaunchCmdLookup,
						(MemPtr)&params, &result);
	if (err) {
		ErrMsgRes(err, strErrAddrBook);
		return 0;
	}
	return(params.resultStringH);
}

extern Char *InsertText;

Boolean MainFormHandleEvent (EventPtr e)
{
    Boolean handled = false, sendok;
    FormPtr frm;
    FieldPtr fld;
    ListPtr lst;
	ControlPtr ctl;
    ScrollBarPtr scl;
    EventType evt;
    UInt16 i, l, r, recSize, numphones, numpages;
    Int16 im, rus, repl;
	Boolean restForm;
	SizeSMSType msgsize;
    Char *smsc, *phone, *text, stl[8], str[161];
	UInt8 b, *ref, *p;
	Char *sp, *st;
	static RectangleType PhoneLabel, TextLabel;
	RectangleType fbounds, sbounds;
	static Boolean PhoneScrollable;
	Int16 scrollAdd, scrollPos, textHeight, fieldHeight, maxValue;
	static Coord py;
	PhoneType *PhoneList;
	MemHandle phoneH;
//oleg new
	RectangleType rect;
	RectangleType bounds;
	
    CALLBACK_PROLOGUE
		
	switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
		FrmGetObjectBounds(frm,
				   FrmGetObjectIndex(frm, MainForm_PhoneLabel),
				   &PhoneLabel);
		FrmGetObjectBounds(frm,
				   FrmGetObjectIndex(frm, MainForm_TextLabel),
				   &TextLabel);
		PhoneScrollable = false;
		fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PhoneEntry));
//		fld->rect.extent.x = 159 - 8 - fld->rect.topLeft.x;
		FldGetBounds(fld, &rect);
		rect.extent.x = 159 - 8 - rect.topLeft.x;
		FldSetBounds(fld, &rect);
//		py = fld->rect.extent.y-1;
		py = rect.extent.y-1;
//		scl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PhoneScrollBar));
		FrmGetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_PhoneScrollBar),
			&bounds);

		bounds.extent.y = rect.extent.y;
		FrmSetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_PhoneScrollBar),
			&bounds);

		fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_TextEntry));
//		fld->rect.extent.x = 159 - 8 - fld->rect.topLeft.x;
		FldGetBounds(fld, &rect);
		rect.extent.x = 159 - 8 - rect.topLeft.x;
		FldSetBounds(fld, &rect);
//		ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_SendButton));
		FrmGetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_SendButton),
			&bounds);
//		fld->rect.extent.y = ctl->bounds.topLeft.y - fld->rect.topLeft.y - 1;
		FldGetBounds(fld, &rect);
		rect.extent.y = bounds.topLeft.y - rect.topLeft.y - 1;
		FldSetBounds(fld, &rect);
//		scl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_TextScrollBar));
		FrmGetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_TextScrollBar),
			&bounds);
		bounds.extent.y = rect.extent.y;
		FrmSetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_TextScrollBar),
			&bounds);

		lst = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PortList));
		LstSetListChoices(lst, globalConn.list, globalConn.cnt);
		LstSetHeight(lst, (globalConn.cnt>11?11:globalConn.cnt));
		LstSetSelection(lst, globalConn.sel);
		FrmGetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_PortList),
			&bounds);
		bounds.extent.x = 3 +
			MaxStringLenInPixel(globalConn.list, globalConn.cnt, lst->font);
		FrmSetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_PortList),
			&bounds);

		CtlSetLabel(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PortPopup)), \
					globalConn.list[globalConn.sel]);
		lst = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_SmscList));
		LstSetListChoices(lst, globalSmsc.name, globalSmsc.cnt);
		LstSetHeight(lst, (globalSmsc.cnt>10?10:globalSmsc.cnt));
		LstSetSelection(lst, globalSmsc.sel);
		FrmGetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_SmscList),
			&bounds);
		bounds.extent.x = 3 +
			MaxStringLenInPixel(globalSmsc.name, globalSmsc.cnt, lst->font);
		FrmSetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_SmscList),
			&bounds);

		CtlSetLabel(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_SmscPopup)), \
					globalSmsc.name[globalSmsc.sel]);

		/* Restore Main Form */
		restForm = false;
		while (1) {
			recSize = 0;
			if (PrefGetAppPreferences(APPID, usmsSaveMainFormID, NULL, &recSize, false) ==
				noPreferenceFound)
				break;
			if ((p = ref = (UInt8*)MemPtrNew(recSize)) == NULL) {
				SystemError(memErrNotEnoughSpace);
				break;
			}
			PrefGetAppPreferences(APPID, usmsSaveMainFormID, ref, &recSize, false);
			MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
			if (l != usmsPrefVer) {
				MemPtrFree(ref);
				break;
			}
			/* RusCheck, ReplCheck, ImCheck */
			b = *p;
			p++;
			rus = (b & RusFlag) > 0;
			im  = (b & ImFlag) > 0;
			repl= (b & ReplFlag) > 0;
			if (im) rus = 0;
			if (rus && globalSmsc.flags[globalSmsc.sel].NoUCS2)
				rus = 0;
			if (repl && globalSmsc.flags[globalSmsc.sel].NoRepl)
				repl = 0;
			CtlSetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_RusCheck)), rus);
			CtlSetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_ImCheck)), im);
			CtlSetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_ReplCheck)), repl);

			/* Unused */
			p++;
			
			/* Phone Entry */
			MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
			if (l > 0) {
				if ((sp = (Char*)MemPtrNew(sizeof(Char)*l)) == NULL) {
					SystemError(memErrNotEnoughSpace);
					MemPtrFree(ref);
					break;
				}
				MemMove(sp, p, l);
				p += l;
				SetFieldTextFromStr(MainForm_PhoneEntry, sp);
				MemPtrFree(sp);
				fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PhoneEntry));
				MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
				FldSetInsPtPosition(fld, l);
				MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
				FldSetScrollPosition(fld, l);
				MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
				MemMove(&r, p, sizeof(UInt16)); p += sizeof(UInt16);
				FldSetSelection(fld, l, r);
			}
			
			/* Text Entry */
			MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
			if (l > 0) {
				if ((st = (Char*)MemPtrNew(sizeof(Char)*l)) == NULL) {
					SystemError(memErrNotEnoughSpace);
					MemPtrFree(ref);
					break;
				}
				MemMove(st, p, l);
				p += l;
				SetFieldTextFromStr(MainForm_TextEntry, st);
				MemPtrFree(st);
				fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_TextEntry));
				MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
				FldSetInsPtPosition(fld, l);
				MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
				FldSetScrollPosition(fld, l);
				MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
				MemMove(&r, p, sizeof(UInt16)); p += sizeof(UInt16);
				FldSetSelection(fld, l, r);
			}
			
			/* Set focus */
			MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
			FrmSetFocus(frm, FrmGetObjectIndex(frm, l));

			MemPtrFree(ref);
			restForm = true;
			break;
		}

		if (!restForm) {
			
			SetFieldTextFromStr(MainForm_TextEntry, "");
			CtlSetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_RusCheck)), 0);
			CtlSetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_ImCheck)), 0);
			CtlSetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_ReplCheck)), 0);
			SetFieldTextFromStr(MainForm_PhoneEntry, "+");
			FrmSetFocus(frm, FrmGetObjectIndex(frm, MainForm_PhoneEntry));
		}
        FrmDrawForm(frm);
		evt.eType = evtMainFormTextLenUpdateEvent;
		EvtAddEventToQueue(&evt);
		evt.eType = evtMainFormPhoneScrollableUpdateEvent;
		EvtAddEventToQueue(&evt);
        handled = true;
        break;

	case frmSaveEvent:
		frm = FrmGetActiveForm();
		sp = FldGetTextPtr(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_PhoneEntry)));
		if (sp == NULL) l = 0; else l = StrLen(sp)+1;
		st = FldGetTextPtr(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_TextEntry)));
		if (st == NULL) r = 0; else r = StrLen(st)+1;
		recSize =
			sizeof(UInt16) + /* usmsPrefVer */
			sizeof(UInt8) + /* RusCheck, ImCheck, ReplCheck */
			sizeof(UInt8)+ /* Unused */
			sizeof(UInt16); /* Phone length */
		if (sp != NULL)
			recSize +=
				l + /* Phone */
				sizeof(UInt16) + /* Phone InsPtPos */
				sizeof(UInt16) + /* Phone ScrollPos */
				sizeof(UInt16) + /* Phone LSel */
				sizeof(UInt16); /* Phone RSel */
		recSize +=
			sizeof(UInt16); /* Text length */
		if (st != NULL)
			recSize +=
				r + /* Text */
				sizeof(UInt16) + /* Text InsPtPos */
				sizeof(UInt16) + /* Text ScrollPos */
				sizeof(UInt16) + /* Text LSel */
				sizeof(UInt16); /* Text RSel */
		recSize +=
			sizeof(UInt16); /* Focus */
		if ((p = ref = (UInt8*)MemPtrNew(recSize)) == NULL) {
			SystemError(memErrNotEnoughSpace);
			break;
		}

		/* usmsPrefVer */
		l = usmsPrefVer;
		MemMove(p, &l, sizeof(UInt16));		p += sizeof(UInt16);

		/* RusCheck, ImCheck, ReplCheck */
		rus = CtlGetValue(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_RusCheck)));
		im = CtlGetValue(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_ImCheck)));
		repl = CtlGetValue(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_ReplCheck)));
		*p = 0;
		if (im) rus = 0;
		if (rus)  *p |= RusFlag;
		if (im)   *p |= ImFlag;
		if (repl) *p |= ReplFlag;
		p++;
		
		/* Unused */
		*p = 0;
		p++;

		/* Phone */
		if (sp == NULL) l = 0; else l = StrLen(sp)+1;
		MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
		if (sp != NULL) {
			MemMove(p, sp, l); p += l;
			fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PhoneEntry));
			l = FldGetInsPtPosition(fld);
			MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
			l = FldGetScrollPosition(fld);
			MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
			FldGetSelection(fld, &l, &r);
			MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
			MemMove(p, &r, sizeof(UInt16));	p += sizeof(UInt16);
		}
		
		/* Text */
		if (st == NULL) l = 0; else l = StrLen(st)+1;
		MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
		if (st != NULL) {
			MemMove(p, st, l); p += l;
			fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_TextEntry));
			l = FldGetInsPtPosition(fld);
			MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
			l = FldGetScrollPosition(fld);
			MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
			FldGetSelection(fld, &l, &r);
			MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);
			MemMove(p, &r, sizeof(UInt16));	p += sizeof(UInt16);
		}

		l = FrmGetObjectId(frm, FrmGetFocus(frm));
		MemMove(p, &l, sizeof(UInt16));	p += sizeof(UInt16);

		PrefSetAppPreferences(APPID, usmsSaveMainFormID, usmsPrefVer,
							  ref, recSize, false);
		MemPtrFree(ref);
		break;

	case evtMainFormSmscListUpdateEvent:
		frm = FrmGetActiveForm();
		lst = FrmGetObjectPtr(frm,
			  FrmGetObjectIndex(frm, MainForm_SmscList));
		LstSetListChoices(lst, globalSmsc.name, globalSmsc.cnt);
		LstSetHeight(lst, (globalSmsc.cnt>10?10:globalSmsc.cnt));
		LstSetSelection(lst, globalSmsc.sel);
		FrmGetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_SmscList),
			&bounds);

		bounds.extent.x = 3 +
			MaxStringLenInPixel(globalSmsc.name, globalSmsc.cnt, lst->font);
		FrmSetObjectBounds(frm,
			FrmGetObjectIndex(frm, MainForm_SmscList),
			&bounds);

		CtlSetLabel(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_SmscPopup)),
					globalSmsc.name[globalSmsc.sel]);
		handled = true;
		break;
		
	case menuEvent:
        MenuEraseStatus(NULL);
		
		switch(e->data.menu.itemID) {
		case MainMenu_PhoneLookup:
			phoneH = MobilePhoneLookup();
			if (phoneH) {
				phone = MemHandleLock(phoneH);
				if (PalmOSVersion < 0x04000000) {
					l = StrLen(phone);
					if (phone[l-1] == 'e')
						phone[l-1] = chrNull;
				}
				SetFieldTextFromStr(MainForm_PhoneEntry, phone);
				MemPtrUnlock(phone);
				MemHandleFree(phoneH);
			}
			break;
		case MainMenu_InsertSms:
			FrmPopupForm(SaveSmsForm);
			break;
		case MainMenu_SaveSms:
			frm = FrmGetActiveForm();
			text = FldGetTextPtr(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_TextEntry)));
 			SaveSms(text);
			break;
		case MainMenu_Ref:
			evt.eType = frmSaveEvent;
			EvtAddEventToQueue(&evt);
			FrmGotoForm(RefForm);
			break;
		case MainMenu_About:
			frm = FrmInitForm(InfoForm);
			FrmDoDialog(frm);
			FrmDeleteForm(frm);
			break;
		default:
			break;
        }
		handled = true;
		if ((fld = GetFocusedField()) != NULL) 
		switch(e->data.menu.itemID) {
		case MainMenu_Undo:
			FldUndo(fld);
			evt.eType = evtMainFormTextLenUpdateEvent;
			EvtAddEventToQueue(&evt);
			evt.eType = evtMainFormPhoneScrollableUpdateEvent;
			EvtAddEventToQueue(&evt);
			break;
		case MainMenu_Cut:
			FldCut(fld);
			evt.eType = evtMainFormTextLenUpdateEvent;
			EvtAddEventToQueue(&evt);
			evt.eType = evtMainFormPhoneScrollableUpdateEvent;
			EvtAddEventToQueue(&evt);
			break;
		case MainMenu_Copy:
			FldCopy(fld);
			break;
		case MainMenu_Paste:
			FldPaste(fld);
			evt.eType = evtMainFormTextLenUpdateEvent;
			EvtAddEventToQueue(&evt);
			evt.eType = evtMainFormPhoneScrollableUpdateEvent;
			EvtAddEventToQueue(&evt);
			break;
		case MainMenu_SelAll:
			FldSetSelection(fld, 0, FldGetTextLength(fld));
			break;
		case MainMenu_Keyb: {
			KeyboardType x = kbdDefault;
//			switch(fld->id) {
			FormPtr form = FrmGetActiveForm();
			UInt16 focus = FrmGetFocus(form);
			switch(FrmGetObjectId(form, focus)) {
			case MainForm_PhoneEntry:
				x = kbdNumbersAndPunc;
				break;
			case MainForm_TextEntry:
				x = kbdDefault;
				break;
			}
			SysKeyboardDialog(x);
			break;
		}
		case MainMenu_Graf:
			SysGraffitiReferenceDialog(referenceDefault);
			break;
		case menuCmdBarOpenEvent:
			FldGetSelection(fld, &l, &r);
			if ((fld) && (l != r)) {
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarPasteBitmap, menuCmdBarResultMenuItem, sysEditMenuPasteCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarCopyBitmap, menuCmdBarResultMenuItem, sysEditMenuCopyCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarCutBitmap, menuCmdBarResultMenuItem, sysEditMenuCutCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarUndoBitmap, menuCmdBarResultMenuItem, sysEditMenuUndoCmd, 0);
			} else {
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarPasteBitmap, menuCmdBarResultMenuItem, sysEditMenuPasteCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarUndoBitmap, menuCmdBarResultMenuItem, sysEditMenuUndoCmd, 0);
			}
			e->data.menuCmdBarOpen.preventFieldButtons = true;
			handled = false;
			break;
		default:
			handled = false;
			break;
		}
        break;
		
	case popSelectEvent:
		switch (e->data.popSelect.controlID) {
		case MainForm_PortPopup:
			if (!globalConn.edit ||
				(LstGetNumberOfItems(e->data.popSelect.listP)-1) !=
				 e->data.popSelect.selection) {
				globalConn.sel = e->data.popSelect.selection;
				break;
			}
			handled = true;
			EditConnList(&globalConn);
			break;

		case MainForm_SmscPopup:
			if (
			(LstGetNumberOfItems(e->data.popSelect.listP)-1) 
			!=
				e->data.popSelect.selection) {
				globalSmsc.sel = e->data.popSelect.selection;
				frm = FrmGetActiveForm();
				if (globalSmsc.flags[globalSmsc.sel].NoUCS2) {
					ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_RusCheck));
					rus = CtlGetValue(ctl);
					if (rus) {
						if (!globalFlags.NoWarn)
							WarnMsgRes(strNoUCS2);
						CtlSetValue(ctl, 0);
					}
				}
				if (globalSmsc.flags[globalSmsc.sel].NoRepl) {
					ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_ReplCheck));
					repl = CtlGetValue(ctl);
					if (repl) {
						if (!globalFlags.NoWarn)
							WarnMsgRes(strNoRepl);
						CtlSetValue(ctl, 0);
					}
				}
				break;
			}
			handled = true;
			LstSetSelection(e->data.popSelect.listP,
							e->data.popSelect.priorSelection);
			FrmPopupForm(SmscRefForm);
			break;
		}
		break;
		
	case penDownEvent:
		if ((e->screenX >= PhoneLabel.topLeft.x) &&
			(e->screenX <= PhoneLabel.topLeft.x + PhoneLabel.extent.x) &&
			(e->screenY >= PhoneLabel.topLeft.y) &&
			(e->screenY <= PhoneLabel.topLeft.y + PhoneLabel.extent.y)) {
			phoneH = MobilePhoneLookup();
			if (phoneH) {
				phone = MemHandleLock(phoneH);
				if (PalmOSVersion < 0x04000000) {
					l = StrLen(phone);
					if (phone[l-1] == 'e')
						phone[l-1] = chrNull;
				}
				SetFieldTextFromStr(MainForm_PhoneEntry, phone);
				MemPtrUnlock(phone);
				MemHandleFree(phoneH);
			}
			handled = true;
		}
		else if ((e->screenX >= TextLabel.topLeft.x) &&
				 (e->screenX <= TextLabel.topLeft.x + TextLabel.extent.x) &&
				 (e->screenY >= TextLabel.topLeft.y) &&
				 (e->screenY <= TextLabel.topLeft.y + TextLabel.extent.y)) {
			FrmPopupForm(SaveSmsForm);
			handled = true;
		}

		break;
		
	case evtMainFormInsertTextEvent:
		handled = true;
		if (InsertText == NULL) break;
		SetFieldTextFromStr(MainForm_TextEntry, InsertText);
		MemPtrFree(InsertText);
		evt.eType = evtMainFormTextLenUpdateEvent;
		EvtAddEventToQueue(&evt);
		break;
		
	case keyDownEvent: {
		FormPtr form = FrmGetActiveForm();
		UInt16 focus = FrmGetFocus(form);

		if ((fld = GetFocusedField()) == NULL) break;
//		switch (fld->id) {
		switch(FrmGetObjectId(form, focus)) {
		case MainForm_TextEntry:
			evt.eType = evtMainFormTextLenUpdateEvent;
			EvtAddEventToQueue(&evt);
			break;
		case MainForm_PhoneEntry:
			evt.eType = evtMainFormPhoneScrollableUpdateEvent;
			EvtAddEventToQueue(&evt);
			break;
		}
		break;
	}
	case evtMainFormPhoneScrollableUpdateEvent:
		frm = FrmGetActiveForm();
		l = FrmGetObjectIndex(frm, MainForm_PhoneEntry);
		fld = FrmGetObjectPtr(frm, l);
		FrmGetObjectBounds(frm, l, &fbounds);
		r = FldCalcFieldHeight(FldGetTextPtr(fld), fbounds.extent.x);
		if (r > 2) {
			scl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PhoneScrollBar));
			FldGetScrollValues (fld, &scrollPos, &textHeight, &fieldHeight);
			if (textHeight > fieldHeight)
				maxValue = textHeight - fieldHeight;
			else if (scrollPos)
				maxValue = scrollPos;
			else
				maxValue = 0;
			SclSetScrollBar (scl, scrollPos, 0, maxValue, fieldHeight-1);
		} else {
			scl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PhoneScrollBar));
			SclSetScrollBar (scl, 0, 0, 0, 0);
		}
		if (r > 1) {
			if (PhoneScrollable)
				break;
			PhoneScrollable = true;
			fld->attr.dynamicSize = 0;
			FrmHideObject(frm, l);
			fbounds.extent.y += py;
			FrmSetObjectBounds(frm, l, &fbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_PhoneScrollBar);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &sbounds);
			sbounds.extent.y = fbounds.extent.y;
			FrmSetObjectBounds(frm, l, &sbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_TextLabel);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &sbounds);
			sbounds.topLeft.y += py;
			FrmSetObjectBounds(frm, l, &sbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_TextEntry);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &fbounds);
			fbounds.extent.y -= py;
			fbounds.topLeft.y += py;
			FrmSetObjectBounds(frm, l, &fbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_TextScrollBar);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &sbounds);
			sbounds.extent.y = fbounds.extent.y;
			sbounds.topLeft.y = fbounds.topLeft.y;
			FrmSetObjectBounds(frm, l, &sbounds);
			FrmShowObject(frm, l);
			FrmGetObjectBounds(frm,
							   FrmGetObjectIndex(frm, MainForm_TextLabel),
							   &TextLabel);
			FrmUpdateForm(MainForm, 0);

		} else {
			if (!PhoneScrollable)
				break;
			PhoneScrollable = false;
			fld->attr.dynamicSize = 1;
			FrmHideObject(frm, l);
			fbounds.extent.y -= py;
			FrmSetObjectBounds(frm, l, &fbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_PhoneScrollBar);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &sbounds);
			sbounds.extent.y = fbounds.extent.y;
			FrmSetObjectBounds(frm, l, &sbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_TextLabel);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &sbounds);
			sbounds.topLeft.y -= py;
			FrmSetObjectBounds(frm, l, &sbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_TextEntry);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &fbounds);
			fbounds.extent.y += py;
			fbounds.topLeft.y -= py;
			FrmSetObjectBounds(frm, l, &fbounds);
			FrmShowObject(frm, l);
			l = FrmGetObjectIndex(frm, MainForm_TextScrollBar);
			FrmHideObject(frm, l);
			FrmGetObjectBounds(frm, l, &sbounds);
			sbounds.extent.y = fbounds.extent.y;
			sbounds.topLeft.y = fbounds.topLeft.y;
			FrmSetObjectBounds(frm, l, &sbounds);
			FrmShowObject(frm, l);
			FrmGetObjectBounds(frm,
							   FrmGetObjectIndex(frm, MainForm_TextLabel),
							   &TextLabel);
			FrmUpdateForm(MainForm, 0);
			
		}
		handled = true;
		break;

	case evtMainFormTextLenUpdateEvent:
		frm = FrmGetActiveForm();
		rus = CtlGetValue(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_RusCheck)));
		im = CtlGetValue(FrmGetObjectPtr(
			frm, FrmGetObjectIndex(frm, MainForm_ImCheck)));
		b = 0;
		if (im) rus = 0;
		if (rus)  b |= RusFlag;
		if (im)   b |= ImFlag;
		text = FldGetTextPtr(FrmGetObjectPtr(
								 frm, FrmGetObjectIndex(frm, MainForm_TextEntry)));
		msgsize = SizeSMS(text, b);
		StrPrintF(stl, "%i/%i", msgsize.pages, msgsize.pagelen - msgsize.chars);
		SetFieldTextFromStr(MainForm_TextLen, stl);
		
		fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_TextEntry));
		scl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_TextScrollBar));
		FldGetScrollValues (fld, &scrollPos, &textHeight, &fieldHeight);
		if (textHeight > fieldHeight)
		    maxValue = textHeight - fieldHeight;
		else if (scrollPos)
		    maxValue = scrollPos;
		else
		    maxValue = 0;
		SclSetScrollBar (scl, scrollPos, 0, maxValue, fieldHeight-1);
		FldDrawField(fld);
		handled = true;
		break;

	case  sclRepeatEvent:
		frm = FrmGetActiveForm();
		scl = e->data.sclRepeat.pScrollBar;
		if (e->data.sclRepeat.scrollBarID == MainForm_PhoneScrollBar)
			fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_PhoneEntry));
		else if (e->data.sclRepeat.scrollBarID == MainForm_TextScrollBar)
			fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_TextEntry));
		else
			break;
		scrollAdd = e->data.sclRepeat.newValue - e->data.sclRepeat.value;
		if (abs(scrollAdd) != 0) {
		    FldScrollField(fld, abs(scrollAdd),
						   (scrollAdd>0?winDown:winUp));
			FldDrawField(fld);
		}
		break;

    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {
		case MainForm_RusCheck:
			frm = FrmGetActiveForm();
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_ImCheck));
			if (e->data.ctlSelect.on) {
				if (globalSmsc.flags[globalSmsc.sel].NoUCS2)
					if (!globalFlags.NoWarn)
						WarnMsgRes(strNoUCS2);
				if (CtlGetValue(ctl))
					CtlSetValue(ctl, 0);
			}
			evt.eType = evtMainFormTextLenUpdateEvent;
			EvtAddEventToQueue(&evt);
			break;
		case MainForm_ImCheck:
			frm = FrmGetActiveForm();
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, MainForm_RusCheck));
			if (e->data.ctlSelect.on)
				if (CtlGetValue(ctl))
					CtlSetValue(ctl, 0);
			evt.eType = evtMainFormTextLenUpdateEvent;
			EvtAddEventToQueue(&evt);
			break;
		case MainForm_ReplCheck:
			frm = FrmGetActiveForm();
			if (e->data.ctlSelect.on)
				if (globalSmsc.flags[globalSmsc.sel].NoRepl)
					if (!globalFlags.NoWarn)
						WarnMsgRes(strNoRepl);
			break;
		case MainForm_ClearButton:
			frm = FrmGetActiveForm();
			SetFieldTextFromStr(MainForm_PhoneEntry, "+");
			SetFieldTextFromStr(MainForm_TextEntry, "");
			evt.eType = evtMainFormTextLenUpdateEvent;
			EvtAddEventToQueue(&evt);
			evt.eType = evtMainFormPhoneScrollableUpdateEvent;
			EvtAddEventToQueue(&evt);
			handled = true;
			break;
		case MainForm_SendButton:
			handled = true;
			frm = FrmGetActiveForm();
			smsc = (Char*)CtlGetLabel(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_SmscPopup)));
			rus = CtlGetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_RusCheck)));
			im = CtlGetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_ImCheck)));
			repl = CtlGetValue(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, MainForm_ReplCheck)));
			if (rus && globalSmsc.flags[globalSmsc.sel].NoUCS2)
				if (!globalFlags.NoWarn)
					WarnMsgRes(strNoRepl);
			if (repl && globalSmsc.flags[globalSmsc.sel].NoRepl)
				if (!globalFlags.NoWarn)
					WarnMsgRes(strNoRepl);
			b = 0;
			if (im) rus = 0;
			if (rus)  b |= RusFlag;
			if (im)   b |= ImFlag;
			if (repl) b |= ReplFlag;
			recSize = MakePhoneList(FldGetTextPtr(
										FrmGetObjectPtr(frm, FrmGetObjectIndex(
															frm, MainForm_PhoneEntry))),
									&PhoneList);
			if (recSize == 0) {
				ErrMsgRes(0, strPhoneIsEmpty);
				FreePhoneList(&PhoneList, recSize);
				break;
			}
			r = 0;
			for (l=0, numphones=0; l<recSize; l++)
				if (PhoneList[l].empty || PhoneList[l].bad) {
					if (recSize > 1) {
						if (FrmCustomAlert(BadPhoneAlert, PhoneList[l].num, "", "") == 1) {
							r = 1;
							FreePhoneList(&PhoneList, recSize);
							break;
						}
					} else {
						ErrMsgRes(0, strPhoneIsBad);
						r = 1;
						FreePhoneList(&PhoneList, recSize);
						break;
					}
				} else
					numphones++;
			if (r) {
				FreePhoneList(&PhoneList, recSize);
				break;
			}
					
			text = FldGetTextPtr(FrmGetObjectPtr(
					   frm, FrmGetObjectIndex(frm, MainForm_TextEntry)));
			msgsize = SizeSMS(text, b);
			numpages = msgsize.pages;
			if (msgsize.chars == 0) numpages--;
			if (!globalFlags.NoWarn)
				if ((numphones*numpages) > 1)
					if (FrmCustomAlert(MoreSmsAlert, StrIToA(stl, numphones*numpages), "", "") == 1) {
						FreePhoneList(&PhoneList, recSize);
						break;
					}
			if (!SendSmsStart()) {
				FreePhoneList(&PhoneList, recSize);
				break;
			}
			sendok = true;
			i = 1;
			for (r=0; r<recSize; r++) {
				if (PhoneList[r].empty || PhoneList[r].bad)
					continue;
				for (l=0; l<numpages; l++) {
					StrNCopy(str, &text[msgsize.pagelen*l], msgsize.pagelen);
					str[msgsize.pagelen] = chrNull;
					if (!SendSmsMessage(smsc, PhoneList[r].num, b, str, i++, numphones*numpages)) {
						sendok = false;
						r = recSize;
						break;
					}
				}
			}
			if (sendok) {
				SendSmsEnd();
				if (globalFlags.AutoSaveSms)
					SaveSms(text);
			}
			FreePhoneList(&PhoneList, recSize);
			break;
        }
        break;
		
    default:
        break;
    }
	
    CALLBACK_EPILOGUE

    return handled;
}
