// -*- C++ -*-
// File: MakeSms.c
//
// Created: Sat Dec  2 23:24:08 2000
//
// $Id: MakeSms.c,v 1.1.1.1 2002/07/17 12:47:32 oskin Exp $
//

#include <PalmOS.h>
#include "callback.h"
#include "RuSMS.h"
#include "encoding.h"

Char *tblTranslit[] =
{"yu","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o",
 "p","ya","r","s","t","u","zh","v","'","y","z","sh","e","sch","ch","'",
 "YU","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O",
 "P","YA","R","S","T","U","ZH","V","'","Y","Z","SH","E","SCH","CH","'"};

WChar tblUnicode_koi8r[128] =
{0x2500,0x2502,0x250c,0x2510,0x2514,0x2518,0x251c,0x2524,
 0x252c,0x2534,0x253c,0x2580,0x2584,0x2588,0x258c,0x2590,
 0x2591,0x2592,0x2593,0x2320,0x25a0,0x2219,0x221a,0x2248,
 0x2264,0x2265,0x00a0,0x2321,0x00b0,0x00b2,0x00b7,0x00f7,
 0x2550,0x2551,0x2552,0x0451,0x2553,0x2554,0x2555,0x2556,
 0x2557,0x2558,0x2559,0x255a,0x255b,0x255c,0x255d,0x255e,
 0x255f,0x2560,0x2561,0x0401,0x2562,0x2563,0x2564,0x2565,
 0x2566,0x2567,0x2568,0x2569,0x256a,0x256b,0x256c,0x00a9,
 0x044e,0x0430,0x0431,0x0446,0x0434,0x0435,0x0444,0x0433,
 0x0445,0x0438,0x0439,0x043a,0x043b,0x043c,0x043d,0x043e,
 0x043f,0x044f,0x0440,0x0441,0x0442,0x0443,0x0436,0x0432,
 0x044c,0x044b,0x0437,0x0448,0x044d,0x0449,0x0447,0x044a,
 0x042e,0x0410,0x0411,0x0426,0x0414,0x0415,0x0424,0x0413,
 0x0425,0x0418,0x0419,0x041a,0x041b,0x041c,0x041d,0x041e,
 0x041f,0x042f,0x0420,0x0421,0x0422,0x0423,0x0416,0x0412,
 0x042c,0x042b,0x0417,0x0428,0x042d,0x0429,0x0427,0x042a};



Char *koi2trlit(UChar c) {
	static Char s[2] = {0, 0};
	if (c == 0xa3) return "e";
	if (c == 0xb3) return "E";
	if (c >= 0xc0) return tblTranslit[c - 0xc0];
	s[0] = c;
	return s;
}

UInt8 badChars(UInt8 c) {
	switch(c) {
	case 0x40: c = 0x00; break;
	case 0x60: c = 0x27; break;
	case 0x5b: c = 0x28; break;
	case 0x7b: c = 0x28; break;
	case 0x5c: c = 0x2f; break;
	case 0x7c: c = 0x21; break;
	case 0x5d: c = 0x29; break;
	case 0x7d: c = 0x29; break;
	case 0x5f: c = 0x40; break;
	}
	return c;
}

WChar tounicode(UChar c, EncType srcenc) {
	c = ToKOI8R(c, srcenc);
	if ((UInt8)c < 0x80) return (0x0000 | (UInt8)c);
	return tblUnicode_koi8r[(UInt8)c - 0x80];
}

UInt16 MakeSCA(Char *smsc, UInt8 *data) {
	Int16 i, di, c;
	Char *p, *phone;
	i = SmscGetIndex(globalSmsc, smsc);
	if ((i < 0) || (StrLen(globalSmsc.phone[i]) == 0)) {
		data[0] = 0;
		return 1;
	}
	p = phone = PhoneToDigits(globalSmsc.phone[i]);
	if (*p == chrPlusSign) {
		data[1] = 0x91;
		p++;
	} else
		data[1] = 0x81;
	di = 2;
	i = 0;
	while( *p != chrNull) {
		c = *p - chrDigitZero;
		if ((i % 2) == 0)
			data[di] = c;
		else {
			data[di] |= c << 4;
			di++;
		}
		i++;
		p++;
	}
	MemPtrFree(phone);
	if ((i % 2) != 0) {
		data[di] |= 0xf0;
		di++;
	}
	data[0] = di - 1;
	return di;
}

UInt16 MakeDA(Char *phone, UInt8 *data) {
	Int16 i, di, c;
	Char *p, *ph;

	p = ph = PhoneToDigits(phone);
	if (*p == chrPlusSign) {
		data[1] = 0x91;
		p++;
	} else
		data[1] = 0x81;
	di = 2;
	i = 0;
	while( *p != chrNull) {
		c = *p - chrDigitZero;
		if ((i % 2) == 0)
			data[di] = c;
		else {
			data[di] |= c << 4;
			di++;
		}
		i++;
		p++;
	}
	MemPtrFree(ph);
	if ((i % 2) != 0) {
		data[di] |= 0xf0;
		di++;
	}
	data[0] = i;
	return di;
}

Char *MakePduString(Char *pduStr, UInt8 *data, UInt16 len) {
	Char *p;
	UInt16 i;
	UInt8 b;

	p = pduStr;
	for (i = 0; i < len; i++) {
		b = (data[i] & 0xf0) >> 4;
		if (b < 0xA)
			*p = b + '0';
		else
			*p = b - 0xA + 'A';
		p++;
		b = data[i] & 0x0f;
		if (b < 0xA)
			*p = b + '0';
		else
			*p = b - 0xA + 'A';
		p++;
	}
	*p = '\0';
	return pduStr;
}

UInt8 MakeDCS(Char *text) {
	
	while (*text != chrNull) {
		if ((UInt8)*text > 0x7f)
			return 0x08;
		text++;
	}
	return 0x00;
}

SizeSMSType SizeSMS(Char *text, UInt8 flags)
{
	Boolean lat = true;
	Char *p = text;
	UInt16 l;
	EncType enc;
	SizeSMSType ret;
	
	ret.pages = 0;
	ret.chars = 0;
	ret.pagelen = Latin1PageSize;
	
	if (text == NULL)
		return ret;
	
	while (*p != chrNull) {
		if ((UInt8)*p++ > 0x7f) {
			lat = false;
			break;
		}
	}
	l = StrLen(text);
	if (lat) {
		ret.pages = 1 + l / ret.pagelen;
		ret.chars = l % ret.pagelen;
		return ret;
	}
	if (flags & RusFlag) {
		ret.pagelen = USC2PageSize;
		ret.pages = 1 + l / ret.pagelen;
		ret.chars = l % ret.pagelen;
		return ret;
	}
	enc = GetEnc();
	p = text;
	l = 0;
	while (*p != chrNull)
		l += StrLen(koi2trlit(ToKOI8R(*p++, enc)));
	ret.pages = 1 + l / ret.pagelen;
	ret.chars = l % ret.pagelen;
	return ret;
}

UInt16 MakeText(Char *text, UInt8 flags, UInt8 *dcs, UInt8 *data) {

	UInt16 len, i, j, dlen, dOffs;
	UInt8 bt;
	EncType srcEncoding;
	Char *p, *buf, tmp[(160+1)*2];
	WChar w;

	*dcs = MakeDCS(text);
	if (((flags & RusFlag) == 0) && (*dcs == 0x08)) { /* To translit */
		srcEncoding = GetEnc();
		p = text;
		buf = tmp;
		buf[0] = chrNull;
		while (*p != chrNull) StrCat(buf, koi2trlit(ToKOI8R(*p++, srcEncoding)));
		*dcs = 0x00;
	} else
		buf = text;
	len = StrLen(buf);
	p = buf;
	
	if (*dcs == 0x00) { /* Default alphabet */
		dOffs = 0;
		dlen = 1;
		if (len > 160) len = 160;
		*data++ = (UInt8)(len & 0xff);
		*data = '\0';
		for (i = 0; i < len; i ++) {
			bt = badChars(*p++);
			for (j = 0; j < 7; j ++, bt >>= 1) {
				if (dOffs == 8) {
					dOffs = 0;
					dlen++;
					*(++data) = (UInt8)'\0';
				}
				*data = (*data) | ((bt & 0x01) << dOffs++);
			}
		}
		if (flags & ImFlag) *dcs = 0xf0;
		return dlen + 1;
	}
	/* Unicode */
	srcEncoding = GetEnc();
	if (len > 70) len = 70;
	*data++ = (UInt8)((len * 2) & 0xff);
	dlen = 1;
	for (i = 0; i < len; i ++) {
		w = tounicode(*p++, srcEncoding);
		*data++ = (UInt8)((w & 0xff00) >> 8);
		*data++ = (UInt8)(w & 0x00ff);
		dlen += 2;
	}
	return dlen;
}

UInt16 MakePduData(Char *pduStr, Char *smsc, Char *phone, UInt8 flags, Char *text) {
	UInt8 data[256+1], *d, *dcs;
	UInt16 dataLen, c, pdulen;

	pdulen = 0;
	dataLen = 0;
	d = &data[0];
	c = MakeSCA(smsc, d);
	dataLen += c;
	d = &data[dataLen];

	*d = 0x11; /* PDU type: 0 0 0 10 0 01 */
	if (flags & ReplFlag) *d |= 0x20;
	pdulen += 1;
	dataLen += 1;
	d = &data[dataLen];

	*d = 0x00; /* MR */
	pdulen += 1;
	dataLen += 1;
	d = &data[dataLen];

	c = MakeDA(phone, d);
	pdulen += c;
	dataLen += c;
	d = &data[dataLen];
	
	*d = 0x00; /* PID */
	pdulen += 1;
	dataLen += 1;
	d = &data[dataLen];

	dcs = d;
	pdulen += 1;
	dataLen += 1;
	d = &data[dataLen];
	
	*d = 0xAA; /* VP = 4 days */
	pdulen += 1;
	dataLen += 1;
	d = &data[dataLen];

	c = MakeText(text, flags, dcs, d);
	pdulen += c;
	dataLen += c;

	MakePduString(pduStr, data, dataLen);

	return pdulen;
}
