// -*- C++ -*-
// File: RefForm.c
//
// Created: Thu Mar  1 23:02:54 2001
//
// $Id: RefForm.c,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//
#include <PalmOS.h>
#include "callback.h"
#include "RuSMS.h"
#include "encoding.h"

Boolean RefFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
	ControlPtr ctl;
	ListPtr lst;
	EncType enc;
	Char str[8], *s;
	Int16 v;
	RectangleType bounds;

    CALLBACK_PROLOGUE

	switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
		ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_ModemSetup));
		CtlSetValue(ctl, globalFlags.ModemSetup == 0);
		ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_NoWarn));
		CtlSetValue(ctl, globalFlags.NoWarn);
		enc = GetEnc();
		lst = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_EncList));
		LstSetListChoices(lst, EncNames, EncNamesLen);
		LstSetHeight(lst, (EncNamesLen>11?11:EncNamesLen));
		LstSetSelection(lst, enc.enc);
		FrmGetObjectBounds(frm, 
			FrmGetObjectIndex (frm, RefForm_EncList), 
			&bounds);
		bounds.extent.x = 3 +
			MaxStringLenInPixel(EncNames, EncNamesLen, lst->font);
		FrmSetObjectBounds(frm, 
			FrmGetObjectIndex (frm, RefForm_EncList), 
			&bounds);

		ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_EncPopup));
		CtlSetLabel(ctl, EncNames[enc.enc]);
		if (enc.loc != LocNone)
			CtlSetEnabled(ctl, false);
		StrIToA(str, globalFlags.Timeout);
		SetFieldTextFromStr(RefForm_TimeoutEntry, str);
		StrIToA(str, globalFlags.SWait);
		SetFieldTextFromStr(RefForm_StartWaitEntry, str);
		StrIToA(str, SysTicksPerSecond());
		SetFieldTextFromStr(RefForm_StartWaitEntry2, str);
		ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_AutoSave));
		CtlSetValue(ctl, globalFlags.AutoSaveSms);
		StrIToA(str, globalFlags.MaxSavedSms);
		SetFieldTextFromStr(RefForm_CntSmsEntry, str);
		
        FrmDrawForm(frm);
        handled = true;
        break;

	case popSelectEvent:
		switch (e->data.popSelect.controlID) {
		case RefForm_EncPopup:
			enc = GetEnc();
			if (enc.loc == LocNone)
				SetEnc(LocNone, e->data.popSelect.selection);
			break;
		}
		break;

    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {
		case RefForm_OkButton:
			handled = true;
			frm = FrmGetActiveForm();
			
			s = FldGetTextPtr(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, RefForm_TimeoutEntry)));
			v = StrAToI(s);
			if (v < 0) v *= -1;
			if (v > 31) {
				ErrMsgRes(0, strBadTimeout);
				SetFieldTextFromStr(RefForm_TimeoutEntry, "31");
				break;
			}
			globalFlags.Timeout = v;
			
			s = FldGetTextPtr(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, RefForm_StartWaitEntry)));
			v = StrAToI(s);
			if (v < 0) v *= -1;
			if (v > 511) {
				ErrMsgRes(0, strBadSWait);
				SetFieldTextFromStr(RefForm_StartWaitEntry, "511");
				break;
			}
			globalFlags.SWait = v;

			s = FldGetTextPtr(FrmGetObjectPtr(
				frm, FrmGetObjectIndex(frm, RefForm_CntSmsEntry)));
			v = StrAToI(s);
			if (v < 0) v *= -1;
			if (v == 0) v = 1;
			globalFlags.MaxSavedSms = v;

			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_ModemSetup));
			globalFlags.ModemSetup = (CtlGetValue(ctl) == 0);
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_NoWarn));
			globalFlags.NoWarn = CtlGetValue(ctl);
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, RefForm_AutoSave));
			globalFlags.AutoSaveSms = CtlGetValue(ctl);
 			FrmGotoForm(MainForm);
			break;
		case RefForm_CancelButton:
			FrmGotoForm(MainForm);
			handled = true;
			break;
		}
		break;

    default:
        break;
    }

    CALLBACK_EPILOGUE

    return handled;
}
