// -*- C++ -*-
// File: RuSMS.c
//
// Created: Mon Jul 24 19:41:32 2000
//
// $Id: RuSMS.c,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//

#include <PalmOS.h>
#include "callback.h"
#define Extern
#include "RuSMS.h"
#include "encoding.h"
#include "cSMS/Serial.h"

static Boolean ApplicationHandleEvent(EventPtr e)
{
    FormPtr frm;
    UInt16  formId;
    Boolean handled = false;
	
    if (e->eType == frmLoadEvent) {
        formId = e->data.frmLoad.formID;
        frm = FrmInitForm(formId);
        FrmSetActiveForm(frm);
		
        switch(formId) {
        case MainForm:
            FrmSetEventHandler(frm, MainFormHandleEvent);
            break;
		case RefForm:
			FrmSetEventHandler(frm, RefFormHandleEvent);
			break;
		case SmscRefForm:
            FrmSetEventHandler(frm, SmscRefFormHandleEvent);
            break;
		case SmscEditForm:
			FrmSetEventHandler(frm, SmscEditFormHandleEvent);
			break;
		case SaveSmsForm:
            FrmSetEventHandler(frm, SaveSmsFormHandleEvent);
            break;
        }
        handled = true;
    }
	
    return handled;
}

static UInt16 oldCurrentSmsc;
static DmOpenRef usmsRes = 0;
static Char StrDefault[30], StrEdit[30];
/*
Char *SN, CSN[14], NOSN = 0;
UInt16 SNL;
*/

/* Get preferences, open (or create) app database */
static UInt16 StartApplication(void)
{
    Err err;
    UInt16 i, recSize;
	DmSearchStateType stateInfo;
	UInt16 cardNoP;
	LocalID dbIDP;
	MemHandle resH;
	MemPtr resP;
	
	if ((usmsRes = DmOpenDatabaseByTypeCreator(
		'Rsrc', 'uSMS', dmModeReadOnly)) == 0) {
		return 1;
	}
	
	err = FtrGet(sysFtrCreator, sysFtrNumROMVersion, &PalmOSVersion);
	if (err) {
		ErrMsgRes(err, strNoROMVersion);
		return 1;
	}
	if (PalmOSVersion < 0x03003000) {
		ErrMsgRes(0, strHaveOS30);
		return 1;
	}

/*	err = SysGetROMToken (0, sysROMTokenSnum,
							 (UInt8**) &SN, &SNL);
	if ((err) || (SN == NULL) || ((UInt8) *SN == 0xFF)) {
		SN = &NOSN;
		SNL = 1;
	}
*/
/* Find shared libs */
	err = DmGetNextDatabaseByTypeCreator(
		true, &stateInfo, 'GLib', 'cSMS', false, &cardNoP, &dbIDP);
	if (err) {
		ErrMsgRes(0, strNoSerialLib);
		return 1;
	}

/*	err = DmGetNextDatabaseByTypeCreator(
		true, &stateInfo, 'GLib', 'lSMS', false, &cardNoP, &dbIDP);
	if (err) {
		ErrMsg(0, "uSMS Language Library not installed.");
		return 1;
	}
*/
	err = SerialInit();
	if (err) {
		if (err != errAlreadyShow)
			SystemError(err);
		return 1;
	}

	/* Find and open SmscDB */
	SmscDB = DmOpenDatabaseByTypeCreator(SmscDBType, APPID,
										 dmModeReadOnly);
	globalSmsc.changed = false;
	globalSmsc.sel = 0;
	if (SmscDB) {
		UInt16 recs, l, r;
		Boolean fl;
		MemHandle recH;
		MemPtr recP, p;
		recs = DmNumRecords(SmscDB);
		globalSmsc.cnt = recs + 2;
		globalSmsc.name =
			(Char**)MemPtrNew(sizeof(Char*)*globalSmsc.cnt);
		globalSmsc.phone =
			(Char**)MemPtrNew(sizeof(Char*)*globalSmsc.cnt);
		globalSmsc.flags =
			(SmscFlagsType*)MemPtrNew(sizeof(SmscFlagsType)*globalSmsc.cnt);
		for (r = 0, i = 1; r < recs; r++, i++) {
			if((recH = DmQueryRecord(SmscDB, r)) == NULL) {
				SystemError(DmGetLastErr());
				return 1;
			}
			recSize = MemHandleSize(recH);
			p = recP = MemHandleLock(recH);
			MemMove(&fl, p, sizeof(Boolean)); p += sizeof(Boolean);
			if (fl) globalSmsc.sel = i;
			MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
			globalSmsc.name[i] = (Char*)MemPtrNew(l);
			MemMove(globalSmsc.name[i], p, l); p += l;
			MemMove(&l, p, sizeof(UInt16)); p += sizeof(UInt16);
			globalSmsc.phone[i] = (Char*)MemPtrNew(l);
			MemMove(globalSmsc.phone[i], p, l); p += l;
			if ((p - recP) < recSize) {
				MemMove(&globalSmsc.flags[i], p,
						sizeof(SmscFlagsType)); p += sizeof(SmscFlagsType);
			} else {
				MemSet(&globalSmsc.flags[i], sizeof(SmscFlagsType), 0);
				globalSmsc.changed = true;
			}
			MemPtrUnlock(recP);
		}
		DmCloseDatabase(SmscDB);
	} else {
		globalSmsc.cnt = 2;
		globalSmsc.name =
			(Char**)MemPtrNew(sizeof(Char*)*globalSmsc.cnt);
		globalSmsc.phone =
			(Char**)MemPtrNew(sizeof(Char*)*globalSmsc.cnt);
		globalSmsc.flags =
			(SmscFlagsType*)MemPtrNew(sizeof(SmscFlagsType)*globalSmsc.cnt);
	}
	i = globalSmsc.cnt - 1;
	resH = DmGetResource('tSTR', strDefault);
	resP = MemHandleLock(resH);
	StrNCopy(StrDefault, resP, 30);
	MemPtrUnlock(resP);
	DmReleaseResource(resH);
	resH = DmGetResource('tSTR', strEdit);
	resP = MemHandleLock(resH);
	StrNCopy(StrEdit, resP, 30);
	MemPtrUnlock(resP);
	DmReleaseResource(resH);
	globalSmsc.name[0] = StrDefault; globalSmsc.phone[0] = "";
	MemSet(&globalSmsc.flags[0], sizeof(SmscFlagsType), 0);
	globalSmsc.name[i] = StrEdit; globalSmsc.phone[i] = "";
	MemSet(&globalSmsc.flags[i], sizeof(SmscFlagsType), 0);
	oldCurrentSmsc = globalSmsc.sel;

/*	StrPrintF(CSN, SNF, SN1, SN2, SN3); */
	
	globalConn.list = NULL; globalConn.cnt = 0;
	err = GetConnList(&globalConn);
    if (err) {
		SystemError(err);
		return 1;
    }
	if (globalConn.edit)
		globalConn.list[globalConn.cnt-1] = StrEdit;
	
	MemSet(&globalFlags, sizeof(globalFlags), 0);
	
	/* Load Saved App Preferences */
	recSize = 0;
	if (PrefGetAppPreferences(APPID, usmsPrefID, NULL, &recSize, true) !=
		noPreferenceFound) {
		UInt8 *ref, *p;
		Char *s;
		if ((p = ref = (UInt8*)MemPtrNew(recSize)) == NULL) {
			SystemError(memErrNotEnoughSpace);
			return 1;
		}
		i = recSize;
		PrefGetAppPreferences(APPID, usmsPrefID, ref, &i, true);
		MemMove(&i, p, sizeof(UInt16)); p += sizeof(UInt16);
		if (i == usmsPrefVer) {
			/* SMSC */
			MemMove(&i, p, sizeof(UInt16)); p += sizeof(UInt16);
			if ((s = (Char*)MemPtrNew(sizeof(Char)*i)) == NULL) {
				SystemError(memErrNotEnoughSpace);
				return 1;
			}
			MemMove(s, p, i); p += i;
			for (i = 0; i < globalConn.cnt; i++) {
				if (StrCompare(globalConn.list[i], s) == 0) {
					globalConn.sel = i;
					break;
				}
			}
			MemPtrFree(s);
			/* globalFlags */
			if ((p - ref) < recSize)
				MemSet(&globalFlags, sizeof(globalFlags), 0);
				i = recSize - (p - ref);
				i = (sizeof(globalFlags) > i) ? i : sizeof(globalFlags);
				MemMove(&globalFlags, p, i); p += i;
		}
		MemPtrFree(ref);
	}
/*	if (globalFlags.encoding == 0) globalFlags.encoding = 1; */
	if (globalFlags.Timeout == 0) globalFlags.Timeout = 15;
	TestEnc();
	if (globalFlags.MaxSavedSms == 0) globalFlags.MaxSavedSms = 1;
	FrmGotoForm(MainForm);
    return 0;
}

/* Save preferences, close forms, close app database */
static void StopApplication(void)
{
    UInt16 i, recSize, recIndex, l;
	UInt32 off;
	Boolean fl;
	MemHandle recH;
	MemPtr recP;
	Err err;
	UInt8 *ref, *p;
	EncType Enc;

	/* Store Saved App Preferences */
	recSize =
		sizeof(UInt16) + /* usmsPrefVer */
		sizeof(UInt16) + /* Conn length */
		StrLen(globalConn.list[globalConn.sel])+1 + /* Conn */
		sizeof(globalFlags);
	Enc = GetEnc(); globalFlags.encoding = Enc.enc;
	if ((p = ref = (UInt8*)MemPtrNew(recSize)) == NULL) {
		SystemError(memErrNotEnoughSpace);
		return;
	}
	i = usmsPrefVer;
	MemMove(p, &i, sizeof(UInt16));	p += sizeof(UInt16);
	i = StrLen(globalConn.list[globalConn.sel])+1;
	MemMove(p, &i, sizeof(UInt16));	p += sizeof(UInt16);
	MemMove(p, globalConn.list[globalConn.sel], i); p += i;
	MemMove(p, &globalFlags, sizeof(globalFlags)); p += sizeof(globalFlags);

    PrefSetAppPreferences(APPID, usmsPrefID, usmsPrefVer, ref,
						  recSize, true);
	MemPtrFree(ref);

    FrmSaveAllForms();
    FrmCloseAllForms();

	/* Saved SmscDB if changed */
	if (globalSmsc.changed || (oldCurrentSmsc != globalSmsc.sel)) {
		SmscDB = DmOpenDatabaseByTypeCreator(SmscDBType, APPID,
											 dmModeReadWrite);
		if (!SmscDB) {
			err = DmCreateDatabase (0, "SmscListDB", APPID, SmscDBType,
									false);
			if (err) {
				SystemError(err);
				return;
			}
			SmscDB = DmOpenDatabaseByTypeCreator(SmscDBType, APPID,
												 dmModeReadWrite);
		} else {
			l = DmNumRecords(SmscDB);
			for (i = 0; i < l; i++) {
				DmRemoveRecord(SmscDB, 0);
			}
		}
		for (i = 1; i < globalSmsc.cnt-1; i++) {
			recSize = sizeof(Boolean) + /* selected */
				sizeof(UInt16) + StrLen(globalSmsc.name[i])+1 + /* Name (len+text) */
				sizeof(UInt16) + StrLen(globalSmsc.phone[i])+1 + /* Phone (len+text) */
				sizeof(SmscFlagsType); /* flags */
			recIndex = dmMaxRecordIndex;
			if (!(recH = DmNewRecord(SmscDB, &recIndex, recSize))) {
				SystemError(DmGetLastErr());
				break;
			}
			recP = MemHandleLock(recH);
			fl = (i == globalSmsc.sel);
			off = 0;
			DmWrite(recP, off, &fl, sizeof(Boolean));
			off += sizeof(Boolean);
			l = StrLen(globalSmsc.name[i])+1;
			DmWrite(recP, off, &l, sizeof(UInt16));
			off +=  sizeof(UInt16);
			DmWrite(recP, off, globalSmsc.name[i], l);
			off += l;
			l = StrLen(globalSmsc.phone[i])+1;
			DmWrite(recP, off, &l, sizeof(UInt16));
			off +=  sizeof(UInt16);
			DmWrite(recP, off, globalSmsc.phone[i], l);
			off += l;
			DmWrite(recP, off, &globalSmsc.flags[i], sizeof(SmscFlagsType));
			off +=  sizeof(SmscFlagsType);
			MemPtrUnlock(recP);
			DmReleaseRecord(SmscDB, recIndex, true);
		}
		DmCloseDatabase(SmscDB);
	}
	for (i = 1; i < globalSmsc.cnt-2; i++ ) {
		MemPtrFree(globalSmsc.name[i]);
		MemPtrFree(globalSmsc.phone[i]);
    }
    MemPtrFree(globalSmsc.name);
    MemPtrFree(globalSmsc.phone);
    MemPtrFree(globalSmsc.flags);

	FreeConnList(&globalConn);
	SerialDone();
	if (usmsRes)
		DmCloseDatabase(usmsRes);
}

/* The main event loop */
static void EventLoop(void)
{
    UInt16 err;
    EventType e;

    do {
        EvtGetEvent(&e, evtWaitForever);
        if (! SysHandleEvent (&e))
            if (! MenuHandleEvent (NULL, &e, &err))
                if (! ApplicationHandleEvent (&e))
                    FrmDispatchEvent (&e);
    } while (e.eType != appStopEvent);
}

/* Main entry point; it is unlikely you will need to change this except to
   handle other launch command codes */
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    UInt16 err;
	switch (cmd) {
	case sysAppLaunchCmdNormalLaunch:
	case sysAppLaunchCmdReturnFromPanel:
		err = StartApplication();
        if (err) return err;
        EventLoop();
        StopApplication();
		break;
	default:
        return sysErrParamErr;
    }

    return 0;
}
