// -*- C++ -*-
// File: RuSMS.h
//
// Created: Thu Dec  5 19:31:16 2000
//
// $Id: RuSMS.h,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//
#ifndef _RUSMS_H_
#define _RUSMS_H_

#include "RuSMSRsc.h"
#include "cSMS/Serial.h"

/*
#define SN1 50
#define SN2 "GK"
#define SN3 14400230
#define SNF "%02d%2s%08ld"
*/

#define usmsPrefID 0x00
#define usmsPrefVer 0x0002
#define usmsSaveMainFormID 0x00

#define RusFlag  0x01
#define ImFlag   0x02
#define ReplFlag 0x04

#define Latin1PageSize 160
#define USC2PageSize 70

typedef struct {
	UInt16 ModemSetup:1;
	UInt16 NoWarn:1;
	UInt16 MaxSavedSms:10;
	UInt16 encoding:4;
	UInt32 Timeout:5;
	UInt32 SWait:9;
	UInt32 AutoSaveSms:1;
	UInt32 reserved2:17;
} SavedFlagsType;

typedef struct {
	UInt16 NoUCS2:1;
	UInt16 NoRepl:1;
	UInt16 reserved:14;
} SmscFlagsType;

typedef struct {
	Char **name;
	Char **phone;
	UInt16 sel;
	UInt16 cnt;
	SmscFlagsType *flags;
	Boolean changed;
} SmscListType;

typedef struct {
	UInt16 pages;
	UInt16 chars;
	UInt16 pagelen;
} SizeSMSType;

typedef struct {
	UInt16 empty:1;
	UInt16 bad:1;
	UInt16 reserved:14;
	Char *num;
} PhoneType;

extern FieldPtr SetFieldTextFromHandle(UInt16 fieldID, MemHandle txtH);
extern FieldPtr SetFieldTextFromStr(UInt16 fieldID, Char* strP);
extern FieldPtr GetFocusedField(void);
extern Int16 StringLenInPixel(Char *text, FontID font);
extern Int16 MaxStringLenInPixel(Char **list, UInt16 cnt, FontID font);
extern UInt16 SystemError(Err err);
extern Int16 SmscGetIndex(SmscListType list, Char *smsc);
extern void SmscSortList(SmscListType list);
extern Boolean ValidCharPhone(Char c);
extern Boolean ValidPhone(Char *str);
extern Char *PhoneToDigits(Char *str);
extern UInt16 MakePhoneList(Char *phone, PhoneType *Phones[]);
extern void FreePhoneList(PhoneType *Phones[], UInt16 cnt);

extern void ErrMsg(Err err, Char *format, ...);
extern void ErrMsgRes(Err err, DmResID format, ...);
extern void WarnMsgRes(DmResID msg);

extern Boolean MainFormHandleEvent (EventPtr e);
// #define updSmscPopup 0x01
// #define updPhoneEntry 0x02

extern Boolean RefFormHandleEvent (EventPtr e);
extern Boolean SmscRefFormHandleEvent (EventPtr e);
extern Boolean SmscEditFormHandleEvent (EventPtr e);
extern Boolean SaveSmsFormHandleEvent (EventPtr e);

extern Boolean SendSmsStart();
extern Boolean SendSmsMessage(Char *smsc, Char *phone, UInt8 flags, Char *text, UInt16 msgnum, UInt16 msgall);
extern Boolean SendSmsEnd();
extern UInt16 MakePduData(Char *pduStr, Char *smsc, Char *phone, UInt8 flags, Char *text);
extern Char *MakePduString(Char *pduStr, UInt8 *data, UInt16 len);
extern SizeSMSType SizeSMS(Char *text, UInt8 flags);
extern void SaveSms(Char *text);

#ifndef Extern
#define Extern extern
#endif
Extern ConnListType globalConn;
Extern SmscListType globalSmsc;
Extern SavedFlagsType globalFlags;
Extern UInt32 PalmOSVersion;

Extern DmOpenRef SmscDB;
#define SmscDBType 'Smsc'
#define SavedSmsDBType 'Smss'

#endif /* _RUSMS_H_ */
