// -*- C++ -*-
// File: SmscForm.c
//
// Created: Mon Jul 24 19:41:32 2000
//
// $Id: SmscEdit.c,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//

#include <PalmOS.h>
#include "callback.h"
#include "RuSMS.h"

extern Int16 EditSmsc;

Boolean SmscEditFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    FieldPtr fld;
	EventType evt;
	ControlPtr ctl;
    UInt16 i, n, startPos, endPos;
	Int16 noucs2, norepl;
    Char *fn, *fp;
	RectangleType rect;

    CALLBACK_PROLOGUE

	switch (e->eType) {
	case frmOpenEvent:
        frm = FrmGetActiveForm();
		fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_Name));
//		fld->rect.extent.x = 154 - fld->rect.topLeft.x;
                FldGetBounds(fld, &rect);
		rect.extent.x = 154 - rect.topLeft.x;
                FldSetBounds(fld, &rect);
		fld = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_Phone));
//		fld->rect.extent.x = 154 - fld->rect.topLeft.x;
                FldGetBounds(fld, &rect);
		rect.extent.x = 154 - rect.topLeft.x;
                FldSetBounds(fld, &rect);

		if (EditSmsc >= 0) {
			SetFieldTextFromStr(SmscEditForm_Name, globalSmsc.name[EditSmsc]);
			SetFieldTextFromStr(SmscEditForm_Phone, globalSmsc.phone[EditSmsc]);
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_UCS2Check));
			CtlSetValue(ctl, globalSmsc.flags[EditSmsc].NoUCS2);
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_ReplCheck));
			CtlSetValue(ctl, globalSmsc.flags[EditSmsc].NoRepl);
		} else {
			SetFieldTextFromStr(SmscEditForm_Phone, "+");
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_UCS2Check));
			CtlSetValue(ctl, 0);
			ctl = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_ReplCheck));
			CtlSetValue(ctl, 0);
		}
		FrmSetFocus(frm, FrmGetObjectIndex(frm, SmscEditForm_Name));
        FrmDrawForm(frm);
        handled = true;
        break;
		
    case menuEvent:
        MenuEraseStatus(NULL);
		if ((fld = GetFocusedField()) != NULL) switch(e->data.menu.itemID) {
		case SmscEditMenu_Undo:
			FldUndo(fld);
			break;
		case SmscEditMenu_Cut:
			FldCut(fld);
			break;
		case SmscEditMenu_Copy:
			FldCopy(fld);
			break;
		case SmscEditMenu_Paste:
			FldPaste(fld);
			break;
		case SmscEditMenu_SelAll:
			FldSetSelection(fld, 0, FldGetTextLength(fld));
			break;
		case SmscEditMenu_Keyb: {
			KeyboardType x = kbdDefault;
			switch(fld->id) {
			case SmscEditForm_Phone:
				x = kbdNumbersAndPunc;
				break;
			case SmscEditForm_Name:
				x = kbdDefault;
				break;
			}
			SysKeyboardDialog(x);
			break;
		}
		case SmscEditMenu_Graf:
			SysGraffitiReferenceDialog(referenceDefault);
			break;
		case menuCmdBarOpenEvent:
			FldGetSelection(fld, &startPos, &endPos);
			if ((fld) && (startPos != endPos)) {
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarPasteBitmap, menuCmdBarResultMenuItem, sysEditMenuPasteCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarCopyBitmap, menuCmdBarResultMenuItem, sysEditMenuCopyCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarCutBitmap, menuCmdBarResultMenuItem, sysEditMenuCutCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarUndoBitmap, menuCmdBarResultMenuItem, sysEditMenuUndoCmd, 0);
			} else {
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarPasteBitmap, menuCmdBarResultMenuItem, sysEditMenuPasteCmd, 0);
				MenuCmdBarAddButton(menuCmdBarOnLeft, BarUndoBitmap, menuCmdBarResultMenuItem, sysEditMenuUndoCmd, 0);
			}
			e->data.menuCmdBarOpen.preventFieldButtons = true;
			handled = false;
			break;
		default:
			handled = false;
			break;
		}
        break;
		
    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {
		case SmscEditForm_OkButton:
			handled = true;
			frm = FrmGetActiveForm();
			fn = FldGetTextPtr(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_Name)));
			if((fn == NULL) || (fn[0] == chrNull) ||
			   IsSpace(GetCharAttr(), fn[0])) {
				ErrMsgRes(0, strNameEmpty);
				break;
			}
			if ((EditSmsc < 0) && (SmscGetIndex(globalSmsc, fn) != -1)) {
				ErrMsgRes(0, strSMSCExist, fn);
				break;
			}
			fp = FldGetTextPtr(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_Phone)));
			if((fp == NULL) || (fp[0] == chrNull) ||
			   IsSpace(GetCharAttr(), fp[0])) {
				ErrMsgRes(0, strPhoneIsEmpty);
				break;
			}
			if(!ValidPhone(fp)) {
				ErrMsgRes(0, strPhoneIsBad);
				break;
			}
			noucs2 = CtlGetValue(
				FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_UCS2Check)));
			norepl = CtlGetValue(
				FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscEditForm_ReplCheck)));
			if(EditSmsc >= 0) {
				n = EditSmsc;
				MemPtrFree(globalSmsc.name[n]);
				MemPtrFree(globalSmsc.phone[n]);
			} else {
				Char **pn, **pp;
				SmscFlagsType *pf;
				n = globalSmsc.cnt;
				n++;
				pn = (Char**)MemPtrNew(sizeof(Char*)*n);
				pp = (Char**)MemPtrNew(sizeof(Char*)*n);
				pf = (SmscFlagsType*)MemPtrNew(sizeof(SmscFlagsType*)*n);
				for (i = 0; i < n-2; i++) {
					pn[i] = globalSmsc.name[i];
					pp[i] = globalSmsc.phone[i];
					pf[i] = globalSmsc.flags[i];
				}
				/* "Edit..." to end of list */
				pn[n-1] = globalSmsc.name[globalSmsc.cnt-1];
				pp[n-1] = globalSmsc.phone[globalSmsc.cnt-1];
				pf[n-1] = globalSmsc.flags[globalSmsc.cnt-1];
				
				MemPtrFree(globalSmsc.name);  globalSmsc.name = pn;
				MemPtrFree(globalSmsc.phone); globalSmsc.phone = pp;
				MemPtrFree(globalSmsc.flags); globalSmsc.flags = pf;
				globalSmsc.cnt = n;
				n -= 2; /* index of new element */
			}
			globalSmsc.name[n] = (Char*)MemPtrNew(StrLen(fn)+1);
			StrCopy(globalSmsc.name[n], fn);
			globalSmsc.phone[n] = (Char*)MemPtrNew(StrLen(fp)+1);
			StrCopy(globalSmsc.phone[n], fp);
			globalSmsc.flags[n].NoUCS2 = noucs2;
			globalSmsc.flags[n].NoRepl = norepl;
			globalSmsc.changed = true;
			SmscSortList(globalSmsc);
		case SmscEditForm_CancelButton:
			FrmReturnToForm(SmscRefForm);
			evt.eType = evtSmscRefFormSmscListUpdateEvent;
			EvtAddEventToQueue(&evt);
			handled = true;
			break;
        }
        break;
		
    default:
        break;
    }
	
    CALLBACK_EPILOGUE

	return handled;
}
