// -*- C++ -*-
// File: RefForm.c
//
// Created: Mon Jul 24 19:41:32 2000
//
// $Id: SmscRef.c,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//

#include <PalmOS.h>
#include "callback.h"
#include "RuSMS.h"

Int16 EditSmsc; /* -1 - add, N - edit N element */

Boolean SmscRefFormHandleEvent (EventPtr e)
{
    Boolean handled = false;
    FormPtr frm;
    ListPtr lst;
	EventType evt;
    UInt16 i;
	Int16 l;

    CALLBACK_PROLOGUE

	switch (e->eType) {
    case frmOpenEvent:
        frm = FrmGetActiveForm();
		lst = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscRefForm_SmscList));
		LstSetListChoices(lst, &globalSmsc.name[1], globalSmsc.cnt-2);
        FrmDrawForm(frm);
        handled = true;
        break;

	case evtSmscRefFormSmscListUpdateEvent:
        frm = FrmGetActiveForm();
		lst = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscRefForm_SmscList));
		LstSetListChoices(lst, &globalSmsc.name[1], globalSmsc.cnt-2);
		LstDrawList(lst);
		handled = true;
		break;

    case ctlSelectEvent:
        switch(e->data.ctlSelect.controlID) {
		case SmscRefForm_DoneButton:
 			FrmReturnToForm(MainForm);
			evt.eType = evtMainFormSmscListUpdateEvent;
			EvtAddEventToQueue(&evt);
			handled = true;
			break;
		case SmscRefForm_NewButton:
			EditSmsc = -1;
			FrmPopupForm(SmscEditForm);
			break;
		case SmscRefForm_EditButton:
			frm = FrmGetActiveForm();
			lst = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscRefForm_SmscList));
			if ((l = LstGetSelection(lst)) == noListSelection) break;
			l++;
			EditSmsc = l;
			FrmPopupForm(SmscEditForm);
			break;
		case SmscRefForm_DelButton:
			frm = FrmGetActiveForm();
			lst = FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, SmscRefForm_SmscList));
			if ((l = LstGetSelection(lst)) == noListSelection) break;
			l++;
			if (FrmCustomAlert(SmscDel, globalSmsc.name[l], "", "") == 0) {
				Char **tn, **tp;
				SmscFlagsType *tf;
				UInt16 x;
				tn = (Char**)MemPtrNew(sizeof(Char*)*(globalSmsc.cnt-1));
				tp = (Char**)MemPtrNew(sizeof(Char*)*(globalSmsc.cnt-1));
				tf = (SmscFlagsType*)MemPtrNew(sizeof(SmscFlagsType)*(globalSmsc.cnt-1));
				for (i = 0, x = 0;  i < globalSmsc.cnt; i++)
					if (i != l) {
						tn[x] = globalSmsc.name[i];
						tp[x] = globalSmsc.phone[i];
						tf[x] = globalSmsc.flags[i];
						x++;
					}
				globalSmsc.cnt--;
				MemPtrFree(globalSmsc.name[l]);
				MemPtrFree(globalSmsc.phone[l]);
				MemPtrFree(globalSmsc.name);
				MemPtrFree(globalSmsc.phone);
				MemPtrFree(globalSmsc.flags);
				globalSmsc.name = tn;
				globalSmsc.phone = tp;
				globalSmsc.flags = tf;
				globalSmsc.changed = true;
				if (globalSmsc.sel >= globalSmsc.cnt-1)
					globalSmsc.sel = 0;
				evt.eType = evtSmscRefFormSmscListUpdateEvent;
				EvtAddEventToQueue(&evt);
			}
			break;
		}
		handled = true;
		break;

    default:
        break;
    }

    CALLBACK_EPILOGUE

    return handled;
}
