// -*- C++ -*-
// File: Serial.h
//
// Created: Sun Jan  7 20:47:41 2001
//
// $Id: Serial.h,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//
#ifndef _Serial_h_
#define _Serial_h_

#include <PalmOS.h>
#include <SerialMgr.h>

struct {
	Char **list;
	UInt16 cnt;
	UInt16 sel;
	Boolean edit;
	UInt16 cardNo;
	LocalID panelID;
} typedef ConnListType;

extern Err SerialInit(void);
extern void SerialDone(void);
extern Err GetConnList(ConnListType *conn);
extern void FreeConnList(ConnListType *conn);
extern Boolean EditConnList(ConnListType *conn);

extern UInt32 SetWaitTime(UInt32 val);
extern UInt16 SerialOpen(ConnListType *conn);
extern void SerialReceiveFlush(UInt16 thePort, UInt16 tics);
extern Err SerialClose(UInt16 thePort);
extern Err SerialReceiveString(UInt16 thePort, Char *rcvDataP, ProgressPtr prgP);
extern Err SerialSendString(UInt16 thePort, Char *data);

#endif /* _Serial_h_ */
