// -*- C++ -*-
// File: ConnList.c
//
// Created: Sun Jan  7 23:50:44 2001
//
// $Id: serConnList.c,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//
// SER
#include "../Serial.h"
#include "../../RuSMSRsc.h"

extern void sErrMsg(Err err, Char *format, ...);
#define ErrMsg sErrMsg

Err GetConnList(ConnListType *conn)
{
	DmSearchStateType searchState;
	
	if (conn->list != NULL) FreeConnList(conn);
	DmGetNextDatabaseByTypeCreator(true, &searchState, 'panl',
								   'SynP', true,  &conn->cardNo,
								   &conn->panelID);
	if (conn->panelID)
		conn->cnt = 11;
	else
		conn->cnt = 10;
	
	if ((conn->list = (Char**)MemPtrNew(sizeof(Char*)*conn->cnt)) == NULL)
		return memErrNotEnoughSpace;
	conn->list[0] = "115200 bps";
	conn->list[1] = "57600 bps";
	conn->list[2] = "38400 bps";
	conn->list[3] = "28800 bps";
	conn->list[4] = "19200 bps";
	conn->list[5] = "14400 bps";
	conn->list[6] = "9600 bps";
	conn->list[7] = "4800 bps";
	conn->list[8] = "2400 bps";
	conn->list[9] = "1200 bps";
	conn->sel = 6;
	if (conn->panelID) {
/* See RuSMS.c		conn->list[10] = "Edit..."; */
		conn->edit = true;
	} else
		conn->edit = false;
	return 0;
}

void FreeConnList(ConnListType *conn)
{
	if (conn->list == NULL) return;
	MemPtrFree(conn->list);
	conn->list = NULL; conn->cnt = 0;
}

Boolean EditConnList(ConnListType *conn)
{
	Err err;
	
	if (conn->edit) {
		err = SysUIAppSwitch(conn->cardNo, conn->panelID,
							 sysAppLaunchCmdPanelCalledFromApp, NULL);
		if (err) {
			ErrMsg(err, "Could not launch Serial/IR panel.");
			return false;
		}
		return true;
	}
	return false;
}
