// -*- C++ -*-
// File: ConnList.c
//
// Created: Sun Jan  7 23:52:48 2001
//
// $Id: srmConnList.c,v 1.1.1.1 2002/07/17 12:47:33 oskin Exp $
//
// SRM
#include "../Serial.h"
#include "../../RuSMSRsc.h"

extern void sErrMsg(Err err, Char *format, ...);
#define ErrMsg sErrMsg

Err GetConnList(ConnListType *conn)
{
	DmSearchStateType searchState;
	Err err;
	Char **newlist;
	
	if (conn->list != NULL) FreeConnList(conn);
	err = CncGetProfileList(&conn->list, &conn->cnt);
	if (err) return err;
	DmGetNextDatabaseByTypeCreator(true, &searchState, 'panl',
								   'modm', true,  &conn->cardNo,
								   &conn->panelID);
	if (conn->panelID) {
		if ((newlist = (Char**)MemPtrNew(sizeof(Char**)*(conn->cnt+1))) == NULL)
			return memErrNotEnoughSpace;
		MemMove(newlist, conn->list, sizeof(Char*)*conn->cnt);
		MemPtrFree(conn->list);
		conn->list = newlist;
/* See RuSMS.c		conn->list[conn->cnt] = "Edit..."; */
		conn->cnt++;
		conn->sel = conn->cnt - 2;
		conn->edit = true;
	} else {
		conn->sel = conn->cnt - 1;
		conn->edit = false;
	}
	return 0;
}

void FreeConnList(ConnListType *conn)
{
	UInt16 i;
	
	if (conn->list == NULL) return;
	if (conn->edit) conn->cnt--;
	for (i = 0; i < conn->cnt; i++)
		MemPtrFree(conn->list[i]);
	MemPtrFree(conn->list);
	conn->list = NULL; conn->cnt = 0; conn->sel = 0;
}

Boolean EditConnList(ConnListType *conn)
{	
	Err err;

	if (conn->edit) {
		err = SysUIAppSwitch(conn->cardNo, conn->panelID,
							 sysAppLaunchCmdPanelCalledFromApp, NULL);
		if (err) {
			ErrMsg(err, "Could not launch Connection panel.");
			return false;
		}
		return true;
	}
	return false;
}
